--- /dev/null	Wed Oct  5 00:31:51 2016
+++ new/usr/src/lib/commpage/Makefile.shared.com	Wed Oct  5 00:31:51 2016
@@ -0,0 +1,33 @@
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+#
+# Copyright 2016 Joyent, Inc.
+#
+
+#
+# This Makefile is shared between both libc and other consumers
+#
+
+COMMPAGE_OBJS = \
+	cp_subr.o \
+	cp_main.o
+
+COMMPAGE_OFFSETS_SRC = $(SRC)/lib/commpage/common/offsets.in
+COMMPAGE_OFFSETS_H = cp_offsets.h
+
+CLEANFILES += $(COMMPAGE_OFFSETS_H)
+
+pics/cp_main.o := CPPFLAGS += -I$(SRC)/uts/i86pc
+pics/cp_subr.o := ASFLAGS += -I$(SRC)/uts/i86pc -I./
+$(COMMPAGE_OFFSETS_H) := CPPFLAGS += -I$(SRC)/uts/i86pc
+
+COMMPAGE_CPPFLAGS = -I$(SRC)/lib/commpage/common
--- /dev/null	Wed Oct  5 00:31:51 2016
+++ new/usr/src/lib/commpage/Makefile.shared.targ	Wed Oct  5 00:31:51 2016
@@ -0,0 +1,29 @@
+#
+# This file and its contents are supplied under the terms of the
+# Common Development and Distribution License ("CDDL"), version 1.0.
+# You may only use this file in accordance with the terms of version
+# 1.0 of the CDDL.
+#
+# A full copy of the text of the CDDL should have accompanied this
+# source.  A copy of the CDDL is also available via the Internet at
+# http://www.illumos.org/license/CDDL.
+#
+
+#
+# Copyright 2016 Joyent, Inc.
+#
+
+#
+# This Makefile is shared between both libc and other consumers
+#
+
+pics/%.o: $(SRC)/lib/commpage/common/%.c
+	$(COMPILE.c) -o $@ $<
+	$(POST_PROCESS_O)
+
+pics/%.o: $(SRC)/lib/commpage/$(TARGET_ARCH)/%.s $(COMMPAGE_OFFSETS_H)
+	$(COMPILE.s) -o $@ $<
+	$(POST_PROCESS_O)
+
+$(COMMPAGE_OFFSETS_H): $(COMMPAGE_OFFSETS_SRC)
+	$(OFFSETS_CREATE) <$(COMMPAGE_OFFSETS_SRC) >$@
--- /dev/null	Wed Oct  5 00:31:51 2016
+++ new/usr/src/lib/commpage/amd64/cp_subr.s	Wed Oct  5 00:31:51 2016
@@ -0,0 +1,406 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2016 Joyent, Inc.
+ */
+
+#include <sys/asm_linkage.h>
+#include <sys/segments.h>
+#include <sys/time_impl.h>
+#include <sys/tsc.h>
+#include <cp_offsets.h>
+
+#define	GETCPU_GDT_OFFSET	SEL_GDT(GDT_CPUID, SEL_UPL)
+
+	.file	"cp_subr.s"
+
+/*
+ * These are cloned from TSC and time related code in the kernel.  They should
+ * be kept in sync in the case that the source values are changed.
+ * See: uts/i86pc/os/timestamp.c
+ */
+#define	NSEC_SHIFT	5
+#define	ADJ_SHIFT	4
+#define	NANOSEC		0x3b9aca00
+
+/*
+ * hrtime_t
+ * __cp_tsc_read(comm_page_t *cp)
+ *
+ * Stack usage: 0 bytes
+ */
+	ENTRY_NP(__cp_tsc_read)
+	movl	CP_TSC_TYPE(%rdi), %esi
+	movl	CP_TSC_NCPU(%rdi), %r8d
+	leaq	CP_TSC_SYNC_TICK_DELTA(%rdi), %r9
+
+	cmpl	$TSC_TSCP, %esi
+	jne	2f
+	rdtscp
+	/*
+	 * When the TSC is read, the low 32 bits are placed in %eax while the
+	 * high 32 bits are placed in %edx.  They are shifted and ORed together
+	 * to obtain the full 64-bit value.
+	 */
+	shlq	$0x20, %rdx
+	orq	%rdx, %rax
+	cmpl	$0, %esi
+	jne	1f
+	ret
+1:
+	/*
+	 * When cp_tsc_ncpu is non-zero, it indicates the length of the
+	 * cp_tsc_sync_tick_delta array, which contains per-CPU offsets for the
+	 * TSC.  The CPU ID furnished by the IA32_TSC_AUX register via rdtscp
+	 * is used to look up an offset value in that array and apply it to the
+	 * TSC reading.
+	 */
+	movq	(%r9, %rcx, 8), %rdx
+	addq	%rdx, %rax
+	ret
+
+2:
+	/*
+	 * Without rdtscp, there is no way to perform a TSC reading and
+	 * simultaneously query the current CPU.  If tsc_ncpu indicates that
+	 * per-CPU TSC offsets are present, the ID of the current CPU is
+	 * queried before performing a TSC reading.  It will be later compared
+	 * to a second CPU ID lookup to catch CPU migrations.
+	 *
+	 * This method will catch all but the most pathological scheduling.
+	 */
+	cmpl	$0, %r8d
+	je	3f
+	movl	$GETCPU_GDT_OFFSET, %edx
+	lsl	%dx, %edx
+
+3:
+	/* Save the most recently queried CPU ID for later comparison. */
+	movl	%edx, %r10d
+
+	cmpl	$TSC_RDTSC_MFENCE, %esi
+	jne	4f
+	mfence
+	rdtsc
+	jmp	7f
+
+4:
+	cmpl	$TSC_RDTSC_LFENCE, %esi
+	jne	5f
+	lfence
+	rdtsc
+	jmp	7f
+
+5:
+	cmpl	$TSC_RDTSC_CPUID, %esi
+	jne	6f
+	/*
+	 * Since the amd64 ABI dictates that %rbx is callee-saved, it must be
+	 * preserved here.  Its contents will be overwritten when cpuid is used
+	 * as a serializing instruction.
+	 */
+	movq	%rbx, %r11
+	xorl	%eax, %eax
+	cpuid
+	rdtsc
+	movq	%r11, %rbx
+	jmp	7f
+
+6:
+	/*
+	 * Other protections should have prevented this function from being
+	 * called in the first place.  The only sane action is to abort.
+	 * The easiest means in this context is via SIGILL.
+	 */
+	ud2a
+
+7:
+	shlq	$0x20, %rdx
+	orq	%rdx, %rax
+
+	/*
+	 * Query the current CPU again if a per-CPU offset is being applied to
+	 * the TSC reading.  If the result differs from the earlier reading,
+	 * then a migration has occured and the TSC must be read again.
+	 */
+	cmpl	$0, %r8d
+	je	8f
+	movl	$GETCPU_GDT_OFFSET, %edx
+	lsl	%dx, %edx
+	cmpl	%edx, %r10d
+	jne	3b
+	movq	(%r9, %rdx, 8), %rdx
+	addq	%rdx, %rax
+8:
+	ret
+	SET_SIZE(__cp_tsc_read)
+
+
+/*
+ * uint_t
+ * __cp_getcpu(comm_page_t *)
+ *
+ * Stack usage: 0 bytes
+ */
+	ENTRY_NP(__cp_getcpu)
+	movl	CP_TSC_TYPE(%rdi), %edi
+	/*
+	 * If RDTSCP is available, it is a quick way to grab the cpu_id which
+	 * is stored in the TSC_AUX MSR by the kernel.
+	 */
+	cmpl	$TSC_TSCP, %edi
+	jne	1f
+	rdtscp
+	movl	%ecx, %eax
+	ret
+1:
+	mov	$GETCPU_GDT_OFFSET, %eax
+	lsl	%ax, %eax
+	ret
+	SET_SIZE(__cp_getcpu)
+
+/*
+ * hrtime_t
+ * __cp_gethrtime(comm_page_t *cp)
+ *
+ * Stack usage: 0x20 local + 0x8 call = 0x28 bytes
+ *
+ * %rsp+0x00 - hrtime_t tsc_last
+ * %rsp+0x08 - hrtime_t hrtime_base
+ * %rsp+0x10 - commpage_t *cp
+ * %rsp+0x18 - int hres_lock
+ */
+	ENTRY_NP(__cp_gethrtime)
+	subq	$0x20, %rsp
+	movq	%rdi, 0x10(%rsp)
+1:
+	movl	CP_HRES_LOCK(%rdi), %r9d
+	movl	%r9d, 0x18(%rsp)
+
+	movq	CP_TSC_LAST(%rdi), %rax
+	movq	CP_TSC_HRTIME_BASE(%rdi), %rdx
+	movq	%rax, (%rsp)
+	movq	%rdx, 0x8(%rsp)
+
+	call	__cp_tsc_read
+	movq	0x10(%rsp), %rdi
+
+	movl	0x18(%rsp), %r9d
+	movl	CP_HRES_LOCK(%rdi), %edx
+	andl	$0xfffffffe, %r9d
+	cmpl	%r9d, %edx
+	jne	1b
+
+	/*
+	 * The in-kernel logic for calculating hrtime performs several checks
+	 * to protect against edge cases.  That logic is summarized as:
+	 * if (tsc >= tsc_last) {
+	 *         delta -= tsc_last;
+	 * } else if (tsc >= tsc_last - 2*tsc_max_delta) {
+	 *         delta = 0;
+	 * } else {
+	 *         delta = MIN(tsc, tsc_resume_cap);
+	 * }
+	 *
+	 * The below implementation achieves the same result, although it is
+	 * structured for speed and optimized for the fast path:
+	 *
+	 * delta = tsc - tsc_last;
+	 * if (delta < 0) {
+	 *         delta += (tsc_max_delta << 1);
+	 *         if (delta >= 0) {
+	 *                 delta = 0;
+	 *         } else {
+	 *                 delta = MIN(tsc, tsc_resume_cap);
+	 *         }
+	 * }
+	 */
+	movq	(%rsp), %rdx
+	subq	%rdx, %rax		/* delta = tsc - tsc_last */
+	jbe	3f			/* if (delta < 0) */
+
+2:
+	/*
+	 * Optimized TSC_CONVERT_AND_ADD:
+	 * hrtime_base += (tsc_delta * nsec_scale) >> (32 - NSEC_SHIFT)
+	 *
+	 * Since the multiply and shift are done in 128-bit, there is no need
+	 * to worry about overflow.
+	 */
+	movl	CP_NSEC_SCALE(%rdi), %ecx
+	mulq	%rcx
+	shrdq	$_CONST(32 - NSEC_SHIFT), %rdx, %rax
+	movq	0x8(%rsp), %r8
+	addq	%r8, %rax
+
+	addq	$0x20, %rsp
+	ret
+
+3:
+	movq	%rax, %r9		/* save (tsc - tsc_last) in r9 */
+	movl	CP_TSC_MAX_DELTA(%rdi), %ecx
+	sall	$1, %ecx
+	addq	%rcx, %rax		/* delta += (tsc_max_delta << 1) */
+	jae	4f			/* delta < 0 */
+	xorq	%rax, %rax
+	jmp	2b
+
+4:
+	/*
+	 * Repopulate %rax with the TSC reading by adding tsc_last to %r9
+	 * (which holds tsc - tsc_last)
+	 */
+	movq	(%rsp), %rax
+	addq	%r9, %rax
+
+	/* delta = MIN(tsc, resume_cap) */
+	movq	CP_TSC_RESUME_CAP(%rdi), %rcx
+	cmpq	%rcx, %rax
+	jbe	5f
+	movq	%rcx, %rax
+5:
+	jmp	2b
+
+	SET_SIZE(__cp_gethrtime)
+
+/*
+ * int
+ * __cp_clock_gettime_monotonic(comm_page_t *cp, timespec_t *tsp)
+ *
+ * Stack usage: 0x8 local + 0x8 call + 0x28 called func. = 0x38 bytes
+ *
+ * %rsp+0x00 - timespec_t *tsp
+ */
+	ENTRY_NP(__cp_clock_gettime_monotonic)
+	subq	$0x8, %rsp
+	movq	%rsi, (%rsp)
+
+	call	__cp_gethrtime
+
+	/*
+	 * Convert from hrtime_t (int64_t in nanoseconds) to timespec_t.
+	 * This uses the same approach as hrt2ts, although it has been updated
+	 * to utilize 64-bit math.
+	 * 1 / 1,000,000,000 =
+	 * 1000100101110000010111110100000100110110101101001010110110011B-26
+	 * = 0x112e0be826d694b3 * 2^-26
+	 *
+	 * secs = (nsecs * 0x112e0be826d694b3) >> 26
+	 *
+	 * In order to account for the 2s-compliment of negative inputs, a
+	 * final operation completes the process:
+	 *
+	 * secs -= (nsecs >> 63)
+	 */
+	movq	%rax, %r11
+	movq	$0x112e0be826d694b3, %rdx
+	imulq	%rdx
+	sarq	$0x1a, %rdx
+	movq	%r11, %rax
+	sarq	$0x3f, %rax
+	subq	%rax, %rdx
+	movq	(%rsp), %rsi
+	movq	%rdx, (%rsi)
+	/*
+	 * Populating tv_nsec is easier:
+	 * tv_nsec = nsecs - (secs * NANOSEC)
+	 */
+	imulq	$NANOSEC, %rdx, %rdx
+	subq	%rdx, %r11
+	movq	%r11, 0x8(%rsi)
+
+	xorl	%eax, %eax
+	addq	$0x8, %rsp
+	ret
+	SET_SIZE(__cp_clock_gettime_monotonic)
+
+/*
+ * int
+ * __cp_clock_gettime_realtime(comm_page_t *cp, timespec_t *tsp)
+ *
+ * Stack usage: 0x18 local + 0x8 call + 0x28 called func. = 0x48 bytes
+ *
+ * %rsp+0x00 - commpage_t *cp
+ * %rsp+0x08 - timespec_t *tsp
+ * %rsp+0x10 - int hres_lock
+ */
+	ENTRY_NP(__cp_clock_gettime_realtime)
+	subq	$0x18, %rsp
+	movq	%rdi, (%rsp)
+	movq	%rsi, 0x8(%rsp)
+
+1:
+	movl	CP_HRES_LOCK(%rdi), %eax
+	movl	%eax, 0x10(%rsp)
+
+	call	__cp_gethrtime
+	movq	(%rsp), %rdi
+	movq	CP_HRES_LAST_TICK(%rdi), %rdx
+	subq	%rdx, %rax			/* nslt = hrtime - last_tick */
+	jb	1b
+	movq	CP_HRESTIME(%rdi), %r9
+	movq	_CONST(CP_HRESTIME + CP_HRESTIME_INCR)(%rdi), %r10
+	movl	CP_HRESTIME_ADJ(%rdi), %r11d
+
+	addq	%rax, %r10			/* now.tv_nsec += nslt */
+
+	cmpl	$0, %r11d
+	jb	4f				/* hres_adj > 0 */
+	ja	6f				/* hres_adj < 0 */
+
+2:
+	cmpq	$NANOSEC, %r10
+	jae	8f				/* tv_nsec >= NANOSEC */
+
+3:
+	movl	0x10(%rsp), %eax
+	movl	CP_HRES_LOCK(%rdi), %edx
+	andl	$0xfffffffe, %edx
+	cmpl	%eax, %edx
+	jne	1b
+
+	movq	0x8(%rsp), %rsi
+	movq	%r9, (%rsi)
+	movq	%r10, 0x8(%rsi)
+
+	xorl	%eax, %eax
+	addq	$0x18, %rsp
+	ret
+
+
+4:						/* hres_adj > 0 */
+	sarq	$ADJ_SHIFT, %rax
+	cmpl	%r11d, %eax
+	jbe	5f
+	movl	%r11d, %eax
+5:
+	addq	%rax, %r10
+	jmp	2b
+
+6:						/* hres_adj < 0 */
+	sarq	$ADJ_SHIFT, %rax
+	negl	%r11d
+	cmpl	%r11d, %eax
+	jbe	7f
+	movl	%r11d, %eax
+7:
+	subq	%rax, %r10
+	jmp	2b
+
+8:						/* tv_nsec >= NANOSEC */
+	subq	$NANOSEC, %r10
+	incq	%r9
+	cmpq	$NANOSEC, %r10
+	jae	8b
+	jmp	3b
+
+	SET_SIZE(__cp_clock_gettime_realtime)
--- /dev/null	Wed Oct  5 00:31:51 2016
+++ new/usr/src/lib/commpage/common/cp_defs.h	Wed Oct  5 00:31:51 2016
@@ -0,0 +1,37 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2016 Joyent, Inc.
+ */
+
+#ifndef	_CP_DEFS_H_
+#define	_CP_DEFS_H_
+
+#include <sys/types.h>
+
+#ifdef	__cplusplus
+extern "C" {
+#endif
+
+struct comm_page;
+typedef struct comm_page comm_page_t;
+
+extern uint_t __cp_can_gettime(comm_page_t *);
+extern hrtime_t __cp_gethrtime(comm_page_t *);
+extern int __cp_clock_gettime_realtime(comm_page_t *, timespec_t *);
+extern int __cp_clock_gettime_monotonic(comm_page_t *, timespec_t *);
+extern uint_t __cp_getcpu(comm_page_t *cp);
+
+#ifdef	__cplusplus
+}
+#endif
+#endif /* _CP_DEFS_H_ */
--- /dev/null	Wed Oct  5 00:31:52 2016
+++ new/usr/src/lib/commpage/common/cp_main.c	Wed Oct  5 00:31:52 2016
@@ -0,0 +1,184 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2016 Joyent, Inc.
+ */
+
+#include <sys/comm_page.h>
+#include <sys/tsc.h>
+
+
+/*
+ * Interrogate if querying the clock via the comm page is possible.
+ */
+int
+__cp_can_gettime(comm_page_t *cp)
+{
+	switch (cp->cp_tsc_type) {
+	case TSC_TSCP:
+	case TSC_RDTSC_MFENCE:
+	case TSC_RDTSC_LFENCE:
+	case TSC_RDTSC_CPUID:
+		return (1);
+	default:
+		break;
+	}
+	return (0);
+}
+
+#ifdef __amd64
+
+/*
+ * The functions used for calculating time (both monotonic and wall-clock) are
+ * implemented in assembly on amd64.  This is primarily for stack conservation.
+ */
+
+#else /* i386 below */
+
+/*
+ * ASM-defined functions.
+ */
+extern hrtime_t __cp_tsc_read(comm_page_t *);
+
+/*
+ * These are cloned from TSC and time related code in the kernel.  The should
+ * be kept in sync in the case that the source values are changed.
+ */
+#define	NSEC_SHIFT	5
+#define	ADJ_SHIFT	4
+#define	NANOSEC		1000000000LL
+
+#define	TSC_CONVERT_AND_ADD(tsc, hrt, scale) do {		\
+	uint32_t *_l = (uint32_t *)&(tsc); 			\
+	uint64_t sc = (uint32_t)(scale);			\
+	(hrt) += (uint64_t)(_l[1] * sc) << NSEC_SHIFT;		\
+	(hrt) += (uint64_t)(_l[0] * sc) >> (32 - NSEC_SHIFT);	\
+} while (0)
+
+/*
+ * Userspace version of tsc_gethrtime.
+ * See: uts/i86pc/os/timestamp.c
+ */
+hrtime_t
+__cp_gethrtime(comm_page_t *cp)
+{
+	uint32_t old_hres_lock;
+	hrtime_t tsc, hrt, tsc_last;
+
+	/*
+	 * Several precautions must be taken when collecting the data necessary
+	 * to perform an accurate gethrtime calculation.
+	 *
+	 * While much of the TSC state stored in the comm page is unchanging
+	 * after boot, portions of it are periodically updated during OS ticks.
+	 * Changes to hres_lock during the course of the copy indicates a
+	 * potentially inconsistent snapshot, necessitating a loop.
+	 *
+	 * Even more complicated is the handling for TSCs which require sync
+	 * offsets between different CPUs.  Since userspace lacks the luxury of
+	 * disabling interrupts, a validation loop checking for CPU migrations
+	 * is used.  Pathological scheduling could, in theory, "outwit"
+	 * this check.  Such a possibility is considered an acceptable risk.
+	 *
+	 */
+	do {
+		old_hres_lock = cp->cp_hres_lock;
+		tsc_last = cp->cp_tsc_last;
+		hrt = cp->cp_tsc_hrtime_base;
+		tsc = __cp_tsc_read(cp);
+	} while ((old_hres_lock & ~1) != cp->cp_hres_lock);
+
+	if (tsc >= tsc_last) {
+		tsc -= tsc_last;
+	} else if (tsc >= tsc_last - (2 * cp->cp_tsc_max_delta)) {
+		tsc = 0;
+	} else if (tsc > cp->cp_tsc_resume_cap) {
+		tsc = cp->cp_tsc_resume_cap;
+	}
+	TSC_CONVERT_AND_ADD(tsc, hrt, cp->cp_nsec_scale);
+
+	return (hrt);
+}
+
+/*
+ * Userspace version of pc_gethrestime.
+ * See: uts/i86pc/os/machdep.c
+ */
+int
+__cp_clock_gettime_realtime(comm_page_t *cp, timespec_t *tsp)
+{
+	int lock_prev, nslt;
+	timespec_t now;
+	int64_t hres_adj;
+
+loop:
+	lock_prev = cp->cp_hres_lock;
+	now.tv_sec = cp->cp_hrestime[0];
+	now.tv_nsec = cp->cp_hrestime[1];
+	nslt = (int)(__cp_gethrtime(cp) - cp->cp_hres_last_tick);
+	hres_adj = cp->cp_hrestime_adj;
+	if (nslt < 0) {
+		/*
+		 * Tick came between sampling hrtime and hres_last_tick;
+		 */
+		goto loop;
+	}
+	now.tv_nsec += nslt;
+
+	/*
+	 * Apply hres_adj skew, if needed.
+	 */
+	if (hres_adj > 0) {
+		nslt = (nslt >> ADJ_SHIFT);
+		if (nslt > hres_adj)
+			nslt = (int)hres_adj;
+		now.tv_nsec += nslt;
+	} else if (hres_adj < 0) {
+		nslt = -(nslt >> ADJ_SHIFT);
+		if (nslt < hres_adj)
+			nslt = (int)hres_adj;
+		now.tv_nsec += nslt;
+	}
+
+	/*
+	 * Rope in tv_nsec from any excessive adjustments.
+	 */
+	while ((unsigned long)now.tv_nsec >= NANOSEC) {
+		now.tv_nsec -= NANOSEC;
+		now.tv_sec++;
+	}
+
+	if ((cp->cp_hres_lock & ~1) != lock_prev)
+		goto loop;
+
+	*tsp = now;
+	return (0);
+}
+
+/*
+ * The __cp_clock_gettime_monotonic function expects that hrt2ts be present
+ * when the code is finally linked.
+ * (The amd64 version has no such requirement.)
+ */
+extern void hrt2ts(hrtime_t, timespec_t *);
+
+int
+__cp_clock_gettime_monotonic(comm_page_t *cp, timespec_t *tsp)
+{
+	hrtime_t hrt;
+
+	hrt = __cp_gethrtime(cp);
+	hrt2ts(hrt, tsp);
+	return (0);
+}
+
+#endif /* __amd64 */
--- /dev/null	Wed Oct  5 00:31:52 2016
+++ new/usr/src/lib/commpage/common/offsets.in	Wed Oct  5 00:31:52 2016
@@ -0,0 +1,35 @@
+\
+\ This file and its contents are supplied under the terms of the
+\ Common Development and Distribution License ("CDDL"), version 1.0.
+\ You may only use this file in accordance with the terms of version
+\ 1.0 of the CDDL.
+\
+\ A full copy of the text of the CDDL should have accompanied this
+\ source.  A copy of the CDDL is also available via the Internet at
+\ http://www.illumos.org/license/CDDL.
+\
+\
+\ Copyright 2016 Joyent, Inc.
+\
+
+
+\
+\ offsets.in: input file to produce assym.h using the ctfstabs program
+\
+
+#include <sys/comm_page.h>
+
+
+comm_page_s	COMM_PAGE_S_SIZE
+	cp_tsc_last
+	cp_tsc_hrtime_base
+	cp_tsc_resume_cap
+	cp_tsc_type
+	cp_tsc_max_delta
+	cp_hres_lock
+	cp_nsec_scale
+	cp_hrestime_adj
+	cp_hres_last_tick
+	cp_tsc_ncpu
+	cp_hrestime
+	cp_tsc_sync_tick_delta
--- /dev/null	Wed Oct  5 00:31:52 2016
+++ new/usr/src/lib/commpage/i386/cp_subr.s	Wed Oct  5 00:31:52 2016
@@ -0,0 +1,157 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2016 Joyent, Inc.
+ */
+
+#include <sys/asm_linkage.h>
+#include <sys/segments.h>
+#include <sys/time_impl.h>
+#include <sys/tsc.h>
+#include <cp_offsets.h>
+
+#define	GETCPU_GDT_OFFSET	SEL_GDT(GDT_CPUID, SEL_UPL)
+
+	.file	"cp_subr.s"
+
+/*
+ * hrtime_t
+ * __cp_tsc_read(uint_t cp_tsc_type)
+ *
+ * Stack usage: 0x18 bytes
+ */
+	ENTRY_NP(__cp_tsc_read)
+	pushl	%ebp
+	movl	%esp, %ebp
+	pushl	%edi
+	pushl	%esi
+	subl	$0x4, %esp
+
+	movl	0x8(%ebp), %edi
+	movl	CP_TSC_TYPE(%edi), %eax
+	movl	CP_TSC_NCPU(%edi), %esi
+	cmpl	$TSC_TSCP, %eax
+	jne	3f
+	rdtscp
+	cmpl	$0, %esi
+	jne	2f
+1:
+	addl	$0x4, %esp
+	popl	%esi
+	popl	%edi
+	leave
+	ret
+2:
+	/*
+	 * When cp_tsc_ncpu is non-zero, it indicates the length of the
+	 * cp_tsc_sync_tick_delta array, which contains per-CPU offsets for the
+	 * TSC.  The CPU ID furnished by the IA32_TSC_AUX register via rdtscp
+	 * is used to look up an offset value in that array and apply it to the
+	 * TSC reading.
+	 */
+	leal	CP_TSC_SYNC_TICK_DELTA(%edi), %esi
+	leal	(%esi, %ecx, 8), %ecx
+	addl	(%ecx), %eax
+	adcl	0x4(%ecx), %edx
+	jmp	1b
+
+3:
+	cmpl	$0, %esi
+	je	4f
+	mov	$GETCPU_GDT_OFFSET, %eax
+	lsl	%ax, %eax
+	movl	%eax, (%esp)
+	movl	CP_TSC_TYPE(%edi), %eax
+
+4:
+	cmpl	$TSC_RDTSC_MFENCE, %eax
+	jne	5f
+	mfence
+	rdtsc
+	jmp	8f
+
+5:
+	cmpl	$TSC_RDTSC_LFENCE, %eax
+	jne	6f
+	lfence
+	rdtsc
+	jmp	8f
+
+6:
+	cmpl	$TSC_RDTSC_CPUID, %eax
+	jne	7f
+	pushl	%ebx
+	xorl	%eax, %eax
+	cpuid
+	rdtsc
+	popl	%ebx
+	jmp	8f
+
+7:
+	/*
+	 * Other protections should have prevented this function from being
+	 * called in the first place.  The only sane action is to abort.
+	 * The easiest means in this context is via SIGILL.
+	 */
+	ud2a
+
+8:
+
+	cmpl	$0, %esi
+	je	1b
+	/*
+	 * With a TSC reading in-hand, confirm that the thread has not migrated
+	 * since the cpu_id was first checked.
+	 */
+	movl	$GETCPU_GDT_OFFSET, %ecx
+	lsl	%cx, %ecx
+	movl	(%esp), %esi
+	cmpl	%ecx, %esi
+	je	9f
+	/*
+	 * There was a CPU migration, perform another reading.
+	 */
+	movl	%eax, (%esp)
+	movl	CP_TSC_NCPU(%edi), %esi
+	movl	CP_TSC_TYPE(%edi), %eax
+	jmp	4b
+
+9:
+	/* Grab the per-cpu offset and add it to the TSC result */
+	leal	CP_TSC_SYNC_TICK_DELTA(%edi), %esi
+	leal	(%esi, %ecx, 8), %ecx
+	addl	(%ecx), %eax
+	adcl	0x4(%ecx), %edx
+	jmp	1b
+	SET_SIZE(__cp_tsc_read)
+
+/*
+ * uint_t
+ * __cp_getcpu(uint_t cp_tsc_type)
+ */
+	ENTRY_NP(__cp_getcpu)
+	/*
+	 * If RDTSCP is available, it is a quick way to grab the cpu_id which
+	 * is stored in the TSC_AUX MSR by the kernel.
+	 */
+	movl	4(%esp), %eax
+	movl	CP_TSC_TYPE(%eax), %eax
+	cmpl	$TSC_TSCP, %eax
+	jne	1f
+	rdtscp
+	movl	%ecx, %eax
+	ret
+1:
+	mov	$GETCPU_GDT_OFFSET, %eax
+	lsl	%ax, %eax
+	ret
+	SET_SIZE(__cp_getcpu)
--- old/usr/src/lib/libbc/inc/include/sys/socket.h	Wed Oct  5 00:31:52 2016
+++ new/usr/src/lib/libbc/inc/include/sys/socket.h	Wed Oct  5 00:31:52 2016
@@ -3,8 +3,6 @@
  * Use is subject to license terms.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 /*
  * Copyright (c) 1982, 1985, 1986 Regents of the University of California.
  * All rights reserved.  The Berkeley software License Agreement
@@ -169,6 +167,4 @@
 #define	MSG_PEEK	0x2		/* peek at incoming message */
 #define	MSG_DONTROUTE	0x4		/* send without using routing tables */
 
-#define	MSG_MAXIOVLEN	16
-
 #endif /*!_sys_socket_h*/
--- old/usr/src/lib/libbrand/common/libbrand.c	Wed Oct  5 00:31:52 2016
+++ new/usr/src/lib/libbrand/common/libbrand.c	Wed Oct  5 00:31:52 2016
@@ -817,6 +817,7 @@
 	xmlNodePtr node;
 	xmlChar *special, *dir, *type, *opt;
 	char special_exp[MAXPATHLEN];
+	char dir_exp[MAXPATHLEN];
 	char opt_exp[MAXPATHLEN];
 	int ret;
 
@@ -843,6 +844,10 @@
 		    special_exp, sizeof (special_exp),
 		    zonename, zonepath, NULL, NULL)) != 0)
 			goto next;
+		if ((ret = i_substitute_tokens((char *)dir,
+		    dir_exp, sizeof (dir_exp),
+		    zonename, zonepath, NULL, NULL)) != 0)
+			goto next;
 
 		/* opt might not be defined */
 		if (strlen((const char *)opt) == 0) {
@@ -855,7 +860,7 @@
 				goto next;
 		}
 
-		ret = func(data, (char *)special_exp, (char *)dir,
+		ret = func(data, (char *)special_exp, (char *)dir_exp,
 		    (char *)type, ((opt != NULL) ? opt_exp : NULL));
 
 next:
--- old/usr/src/lib/libc/Makefile.targ	Wed Oct  5 00:31:52 2016
+++ new/usr/src/lib/libc/Makefile.targ	Wed Oct  5 00:31:52 2016
@@ -21,6 +21,7 @@
 #
 # Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
 # Use is subject to license terms.
+# Copyright 2016 Joyent, Inc.
 #
 #
 
@@ -93,6 +94,10 @@
 	$(BUILD.s)
 	$(POST_PROCESS_O)
 
+pics/%.o: $(LIBCBASE)/../$(MACH)/sys/%.c
+	$(COMPILE.c) -o $@ $<
+	$(POST_PROCESS_O)
+
 pics/%.o: $(LIBCBASE)/../$(TARGET_ARCH)/sys/%.c
 	$(COMPILE.c) -o $@ $<
 	$(POST_PROCESS_O)
--- old/usr/src/lib/libc/amd64/Makefile	Wed Oct  5 00:31:52 2016
+++ new/usr/src/lib/libc/amd64/Makefile	Wed Oct  5 00:31:52 2016
@@ -36,6 +36,10 @@
 CPP=		/usr/lib/cpp
 TARGET_ARCH=	amd64
 
+# include comm page definitions
+include $(SRC)/lib/commpage/Makefile.shared.com
+include $(SRC)/lib/commpage/Makefile.shared.targ
+
 # objects are grouped by source directory
 
 # local objects
@@ -106,6 +110,7 @@
 	strtoull.o
 
 GENOBJS=			\
+	$(COMMPAGE_OBJS)	\
 	_getsp.o		\
 	abs.o			\
 	alloca.o		\
@@ -281,6 +286,7 @@
 
 SYSOBJS=			\
 	__clock_gettime.o	\
+	__clock_gettime_sys.o	\
 	__getcontext.o		\
 	__uadmin.o		\
 	_lwp_mutex_unlock.o	\
@@ -876,6 +882,7 @@
 	fcntl.o			\
 	getpagesizes.o		\
 	getpeerucred.o		\
+	inotify.o		\
 	inst_sync.o		\
 	issetugid.o		\
 	label.o			\
@@ -1059,7 +1066,7 @@
 	$(AR) q $@ `$(LORDER) $(MOSTOBJS:%=$(DIR)/%) | $(GREP) -v ' L ' | $(TSORT)`
 
 # extra files for the clean target
-CLEANFILES=			\
+CLEANFILES+=			\
 	$(LIBCDIR)/port/gen/errlst.c	\
 	$(LIBCDIR)/port/gen/new_list.c	\
 	assym.h			\
@@ -1183,6 +1190,8 @@
 
 pics/arc4random.o :=	CPPFLAGS += -I$(SRC)/common/crypto/chacha
 
+pics/__clock_gettime.o := CPPFLAGS += $(COMMPAGE_CPPFLAGS)
+
 .KEEP_STATE:
 
 all: $(LIBS) $(LIB_PIC)
--- old/usr/src/lib/libc/amd64/gen/siginfolst.c	Wed Oct  5 00:31:52 2016
+++ new/usr/src/lib/libc/amd64/gen/siginfolst.c	Wed Oct  5 00:31:52 2016
@@ -22,6 +22,7 @@
 /*
  * Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ * Copyright 2015, Joyent, Inc.
  */
 
 /*	Copyright (c) 1988 AT&T	*/
@@ -188,6 +189,7 @@
 	0,		0,
 	0,		0,
 	0,		0,			/* SIGRTMIN+15 */
+	0,		0,			/* SIGRTMIN+16 */
 	0,		0,			/* SIGRTMAX-15 */
 	0,		0,
 	0,		0,
--- old/usr/src/lib/libc/i386/Makefile.com	Wed Oct  5 00:31:52 2016
+++ new/usr/src/lib/libc/i386/Makefile.com	Wed Oct  5 00:31:52 2016
@@ -34,6 +34,10 @@
 CPP=		/usr/lib/cpp
 TARGET_ARCH=	i386
 
+# include comm page definitions
+include $(SRC)/lib/commpage/Makefile.shared.com
+include $(SRC)/lib/commpage/Makefile.shared.targ
+
 VALUES=		values-Xa.o
 
 # objects are grouped by source directory
@@ -110,6 +114,7 @@
 	dtrace_data.o
 
 GENOBJS=			\
+	$(COMMPAGE_OBJS)	\
 	_div64.o		\
 	_divdi3.o		\
 	_getsp.o		\
@@ -305,6 +310,7 @@
 
 SYSOBJS=			\
 	__clock_gettime.o	\
+	__clock_gettime_sys.o	\
 	__getcontext.o		\
 	__uadmin.o		\
 	_lwp_mutex_unlock.o	\
@@ -916,6 +922,7 @@
 	fcntl.o			\
 	getpagesizes.o		\
 	getpeerucred.o		\
+	inotify.o		\
 	inst_sync.o		\
 	issetugid.o		\
 	label.o			\
@@ -1120,7 +1127,7 @@
 	$(AR) q $@ `$(LORDER) $(MOSTOBJS:%=$(DIR)/%) | $(GREP) -v ' L ' | $(TSORT)`
 
 # extra files for the clean target
-CLEANFILES=			\
+CLEANFILES+=			\
 	$(LIBCDIR)/port/gen/errlst.c	\
 	$(LIBCDIR)/port/gen/new_list.c	\
 	assym.h			\
@@ -1251,6 +1258,8 @@
 
 pics/arc4random.o :=	CPPFLAGS += -I$(SRC)/common/crypto/chacha
 
+pics/__clock_gettime.o := CPPFLAGS += $(COMMPAGE_CPPFLAGS)
+
 .KEEP_STATE:
 
 all: $(LIBS) $(LIB_PIC)
--- old/usr/src/lib/libc/i386/gen/siginfolst.c	Wed Oct  5 00:31:53 2016
+++ new/usr/src/lib/libc/i386/gen/siginfolst.c	Wed Oct  5 00:31:53 2016
@@ -22,6 +22,7 @@
 /*
  * Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ * Copyright 2015, Joyent, Inc.
  */
 
 /*	Copyright (c) 1988 AT&T	*/
@@ -188,6 +189,7 @@
 	0,		0,
 	0,		0,
 	0,		0,			/* SIGRTMIN+15 */
+	0,		0,			/* SIGRTMIN+16 */
 	0,		0,			/* SIGRTMAX-15 */
 	0,		0,
 	0,		0,
--- /dev/null	Wed Oct  5 00:31:53 2016
+++ new/usr/src/lib/libc/i386/sys/__clock_gettime.c	Wed Oct  5 00:31:53 2016
@@ -0,0 +1,43 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2016 Joyent, Inc.
+ */
+
+
+
+#include "thr_uberdata.h"
+#include <cp_defs.h>
+
+extern int __clock_gettime_sys(clockid_t, timespec_t *);
+
+int
+__clock_gettime(clockid_t clock_id, timespec_t *tp)
+{
+	comm_page_t *cp = (comm_page_t *)__uberdata.ub_comm_page;
+
+	if (cp != NULL && __cp_can_gettime(cp) != 0) {
+		switch (clock_id) {
+		case __CLOCK_REALTIME0:
+		case CLOCK_REALTIME:
+			return (__cp_clock_gettime_realtime(cp, tp));
+
+		case CLOCK_MONOTONIC:
+			return (__cp_clock_gettime_monotonic(cp, tp));
+
+		default:
+			/* Fallback */
+			break;
+		}
+	}
+	return (__clock_gettime_sys(clock_id, tp));
+}
--- old/usr/src/lib/libc/inc/thr_uberdata.h	Wed Oct  5 00:31:53 2016
+++ new/usr/src/lib/libc/inc/thr_uberdata.h	Wed Oct  5 00:31:53 2016
@@ -965,6 +965,7 @@
 	int	ndaemons;	/* total number of THR_DAEMON threads/lwps */
 	pid_t	pid;		/* the current process's pid */
 	void	(*sigacthandler)(int, siginfo_t *, void *);
+	int	(*setctxt)(const ucontext_t *);
 	ulwp_t	*lwp_stacks;
 	ulwp_t	*lwp_laststack;
 	int	nfreestack;
@@ -977,6 +978,8 @@
 	robust_t	**robustlocks;	/* table of registered robust locks */
 	robust_t	*robustlist;	/* list of registered robust locks */
 	char	*progname;	/* the basename of the program, from argv[0] */
+	char	*ub_broot;	/* the root of the native code in the brand */
+	void	*ub_comm_page;	/* arch-specific comm page of kernel data */
 	struct uberdata **tdb_bootstrap;
 	tdb_t	tdb;		/* thread debug interfaces (for libc_db) */
 } uberdata_t;
@@ -1178,6 +1181,7 @@
 	int		ndaemons;
 	int		pid;
 	caddr32_t	sigacthandler;
+	caddr32_t	setctxt;
 	caddr32_t	lwp_stacks;
 	caddr32_t	lwp_laststack;
 	int		nfreestack;
@@ -1190,6 +1194,8 @@
 	caddr32_t	robustlocks;
 	caddr32_t	robustlist;
 	caddr32_t	progname;
+	caddr32_t	ub_broot;
+	caddr32_t	ub_comm_page;
 	caddr32_t	tdb_bootstrap;
 	tdb32_t		tdb;
 } uberdata32_t;
@@ -1279,6 +1285,7 @@
 extern	void	heldlock_exit(void);
 extern	void	heldlock_free(ulwp_t *);
 extern	void	sigacthandler(int, siginfo_t *, void *);
+extern	int	setctxt(const ucontext_t *);
 extern	void	signal_init(void);
 extern	int	sigequalset(const sigset_t *, const sigset_t *);
 extern	void	mutex_setup(void);
--- old/usr/src/lib/libc/port/gen/getauxv.c	Wed Oct  5 00:31:53 2016
+++ new/usr/src/lib/libc/port/gen/getauxv.c	Wed Oct  5 00:31:53 2016
@@ -24,9 +24,8 @@
  * Use is subject to license terms.
  */
 
-#pragma ident	"%Z%%M%	%I%	%E% SMI"
-
 #include "lint.h"
+#include "thr_uberdata.h"
 #include <libc.h>
 #include <fcntl.h>
 #include <stdlib.h>
@@ -38,6 +37,7 @@
 #include <thread.h>
 #include <synch.h>
 #include <atomic.h>
+#include <limits.h>
 
 static mutex_t auxlock = DEFAULTMUTEX;
 
@@ -59,11 +59,20 @@
 	if (auxb == NULL) {
 		lmutex_lock(&auxlock);
 		if (auxb == NULL) {
+			uberdata_t *udp = curthread->ul_uberdata;
 			struct stat statb;
 			auxv_t *buf = NULL;
+			char *path = "/proc/self/auxv";
+			char pbuf[PATH_MAX];
 			int fd;
 
-			if ((fd = open("/proc/self/auxv", O_RDONLY)) != -1 &&
+			if (udp->ub_broot != NULL) {
+				(void) snprintf(pbuf, sizeof (pbuf),
+				    "%s/proc/self/auxv", udp->ub_broot);
+				path = pbuf;
+			}
+
+			if ((fd = open(path, O_RDONLY)) != -1 &&
 			    fstat(fd, &statb) != -1)
 				buf = libc_malloc(
 				    statb.st_size + sizeof (auxv_t));
--- old/usr/src/lib/libc/port/gen/siglist.c	Wed Oct  5 00:31:53 2016
+++ new/usr/src/lib/libc/port/gen/siglist.c	Wed Oct  5 00:31:53 2016
@@ -22,6 +22,7 @@
 /*
  * Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ * Copyright 2015, Joyent, Inc.
  */
 
 /*	Copyright (c) 1988 AT&T	*/
@@ -128,6 +129,7 @@
 		"Fourteenth Realtime Signal",		/* SIGRTMIN+13	*/
 		"Fifteenth Realtime Signal",		/* SIGRTMIN+14	*/
 		"Sixteenth Realtime Signal",		/* SIGRTMIN+15	*/
+		"Seventeenth Realtime Signal",		/* SIGRTMIN+16	*/
 		"Sixteenth Last Realtime Signal",	/* SIGRTMAX-15	*/
 		"Fifteenth Last Realtime Signal",	/* SIGRTMAX-14	*/
 		"Fourteenth Last Realtime Signal",	/* SIGRTMAX-13	*/
--- old/usr/src/lib/libc/port/gen/str2sig.c	Wed Oct  5 00:31:53 2016
+++ new/usr/src/lib/libc/port/gen/str2sig.c	Wed Oct  5 00:31:53 2016
@@ -22,7 +22,7 @@
 /*
  * Copyright 2010 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
- * Copyright (c) 2014, Joyent, Inc.  All rights reserved.
+ * Copyright 2015, Joyent, Inc.
  */
 
 /*	Copyright (c) 1988 AT&T	*/
@@ -102,6 +102,7 @@
 	{ "RTMIN+13",	_SIGRTMIN+13 },
 	{ "RTMIN+14",	_SIGRTMIN+14 },
 	{ "RTMIN+15",	_SIGRTMIN+15 },
+	{ "RTMIN+16",	_SIGRTMIN+16 },
 	{ "RTMAX-15",	_SIGRTMAX-15 },
 	{ "RTMAX-14",	_SIGRTMAX-14 },
 	{ "RTMAX-13",	_SIGRTMAX-13 },
